/*Files to have open:
	Main.cpp
	Menu.h
	Data.h
	Common.h
	Runtime.cpp
*/

// ============================================================================
//
// This file contains the actions, conditions and expressions your object uses
// 
// ============================================================================

#include "Common.h"
#include "ParamHelp.h" //Werbads' float helper param macros and my own PARAM_STRING-to-std::string macros

/* ******* Custom Function Declarations ******* */
//						None

// ============================================================================
//
// CONDITIONS
// 
// ============================================================================

#ifdef NOT_TRUE //My way of commenting stuff out where multiline comments interfere
CONDITION(
	/* ID */			0,
	/* Name */			"%o: %0 == %1",
	/* Flags */			EVFLAGS_ALWAYS|EVFLAGS_NOTABLE,
	/* Params */		(2,PARAM_NUMBER,"First number",PARAM_NUMBER,"Second number")
) {
	int A = Param(TYPE_INT);
	int B = Param(TYPE_INT);
	
	return(A == B);
}


CONDITION(
	/* ID */			1,
	/* Name */			"%o : On trigger",
	/* Flags */			0,
	/* Params */		(0)
) {
	return true;
}
#endif

//If you use this condition, along with its code in Runtime.cpp and Data.h, NO CREDIT IS NEEDED!
CONDITION( //This condition simply waits the specified number of loops before 'allowing' the events to run until it is false
	/* ID */			0,
	/* Name */			"%o: Wait %0 Loops",
	/* Flags */			EVFLAGS_ALWAYS|EVFLAGS_NOTABLE, //Notable! :D Can be useful
	/* Params */		(1,PARAM_NUMBER,"Loops to Wait")
) {
	//Get the Condition ID
	LPRH rhPtr = rdPtr->rHo.hoAdRunHeader;
	unsigned long ID = (unsigned long)rhPtr->rhCurCode;

	//First, set that this condition was checked
	(*rdPtr->Delays)[ID].first = true;

	//if the number of times this condition has triggered is high enough, let it run
	if((*rdPtr->Delays)[ID].second >= (unsigned long)lParam())
	{
		return(true);
	}

	//Obviously the above if statement failed because it didn't return (it would have exited and never gotten here)
	return(false);
}

// ============================================================================
//
// ACTIONS
// 
// ============================================================================

#ifdef NOT_TRUE
ACTION(
	/* ID */			0,
	/* Name */			"Trigger condition",
	/* Flags */			0,
	/* Params */		(0)
) {
	rdPtr->rRd->GenerateEvent(1);
}

ACTION(
	/* ID */			1,
	/* Name */			"Dummy action",
	/* Flags */			0,
	/* Params */		(0)
) {

}
#endif

// ============================================================================
//
// EXPRESSIONS
// 
// ============================================================================

#ifdef NOT_TRUE
EXPRESSION(
	/* ID */			0,
	/* Name */			"Sum(",
	/* Flags */			0,
	/* Params */		(2,EXPPARAM_NUMBER,"First number",EXPPARAM_NUMBER,"Second number")
) {
	int A = ExParam(TYPE_INT);
	int B = ExParam(TYPE_INT);
	
	return(A + B);
}

EXPRESSION(
	/* ID */			1,
	/* Name */			"StringReturn$(",
	/* Flags */			EXPFLAG_STRING,
	/* Params */		(1,EXPPARAM_STRING,"String to return")
) {
	string Str = string((char *)ExParam(TYPE_STRING));

	ReturnString(Str.c_str());
}
#endif